
#include "waili/Wavelet.h"
#include "waili/Channel.h"
#include <stdlib.h>

double *wavelet_gaussian_variance_gain_by_type(u8  type)
{ 
  switch(type) {
  case 100: 
  case 101: 
    { static double g[2]={ 0.647, 1.647  }; return g;}
  case 1:
  case 2:
  case 3:
    { static double g[2]={ 0.50, 2.00 };return g;}
  case 4:
  case 5:
  case 6:
    { static double g[2]={ 0.71, 1.50 };return g;}
  case 7:
    { static double g[2]={ 1.90, 4.43 };return g;}
  case 8:
  case 9:
    { static double g[2]={ 1.63, 4.43 };return g;}
  default: { abort(); static double g[2]={ 1.0, 1.0  }; return g;}
  }
}


double *wavelet_gaussian_variance_gain(Channel *C)
{  
  TransformType  t= ((LChannel *)C)->GetTransformType();
  TransformDescriptor *td=((LChannel *)C)->GetTransform();
  //assert ( t == td->type);
  double *gg=wavelet_gaussian_variance_gain_by_type(td->filter);
  if ( t == TT_ColsRows) {
    double *g=new double[4];
    g[0]= gg[0] * gg[0]; g[1]=g[2]= (gg[0]*gg[1]); g[3]= gg[1] * gg[1];
    return g;
  } else { double *g=new double[4]; g[0]= gg[0]; g[1]=gg[1]; return g;}
}

double *wavelet_uniform_maximum_gain(int type)
{ 
  switch(type) {
  case 100: //ID_CRF_13_7
  case 101: //ID_SWE_13_7
    {  static double g[2]={ 1.45, 2.2  }; return g;}
  case 1://ID_CDF_1_1
  case 2:// ID_CDF_1_
  case 3://ID_CDF_1_5
    {  static double g[2]={ 1.2, 2.0 };return g;}
  case 4://ID_CDF_2_2 = 4
  case 5://ID_CDF_2_4
  case 6://ID_CDF_2_6
    {  static double g[2]={ 1.5, 2.0 };return g;}
  case 7://ID_CDF_4_2
    {  static double g[2]={ 2.2, 3.8 };return g;}
  case 8://ID_CDF_4_4
  case 9://ID_CDF_4_6
    {  static double g[2]={ 2.3, 3.8 };return g;}
  default: {  static double g[2]={ 1.0, 1.0  }; return g;}
  }
}


